#include "Arduino.h"
extern "C" {
  #include "numap.h"
}

unsigned int MaxGold;
unsigned int Gold;
unsigned int StageMap[17][17];

unsigned int Nux;
unsigned int Nuy;

unsigned int StageParts[7][15][5][5];

unsigned int StageParts12[10][5][5] =
{    
  {{2,2,2,2,2},{2,2,2,2,2},{2,2,2,2,2},{2,2,2,2,2},{2,2,2,2,2}},
  {{2,2,0,1,1},{0,0,2,0,2},{0,0,1,1,0},{0,2,0,0,2},{2,0,2,1,1}},
  {{1,1,0,1,1},{1,1,0,1,1},{0,0,2,0,0},{1,1,0,1,1},{1,1,0,1,1}},
  {{1,0,2,0,1},{1,0,0,0,1},{1,2,2,2,1},{1,2,2,2,1},{1,2,2,1,1}},
  {{0,0,0,0,0},{2,1,1,1,2},{0,0,0,0,0},{2,1,1,1,2},{0,0,0,0,0}},
  {{1,1,0,1,1},{1,2,0,2,1},{0,0,2,0,0},{1,2,0,2,1},{1,1,0,1,1}},
  {{1,1,2,1,1},{2,2,2,2,1},{2,2,2,2,1},{2,2,2,2,1},{1,1,2,2,1}},
  {{1,1,2,2,1},{1,2,2,2,1},{1,2,1,1,1},{1,2,2,2,2},{1,1,2,2,2}},
  {{1,2,2,1,1},{1,2,2,2,1},{1,2,2,2,1},{1,2,0,2,1},{1,1,0,1,1}},
  {{1,1,0,1,1},{1,2,0,2,1},{0,0,1,0,0},{1,2,0,2,1},{1,1,0,1,1}}
};

unsigned int StageParts3456[15][5][5] =
{
  {{1,1,1,1,1},{1,1,1,1,1},{2,2,2,1,1},{1,1,2,1,1},{1,1,2,1,1}},
  {{1,1,0,2,2},{1,1,0,2,2},{0,0,0,0,0},{2,2,0,1,1},{2,2,0,1,1}},
  {{1,1,2,2,1},{1,2,2,2,2},{2,2,2,2,2},{1,1,2,2,2},{1,1,2,2,2}},
  {{0,0,0,0,0},{0,0,0,0,0},{0,0,2,0,0},{0,0,0,0,0},{0,0,0,0,0}},
  {{2,2,1,1,1},{2,2,1,1,1},{2,2,1,1,1},{2,2,1,1,1},{2,2,0,0,0}},
  {{2,2,2,2,2},{2,2,2,2,2},{2,2,2,2,2},{2,2,2,2,2},{2,2,2,2,2}},
  {{2,2,2,2,2},{2,2,2,2,2},{2,2,1,2,2},{2,2,1,2,2},{2,2,2,2,2}},
  {{2,2,2,2,2},{2,1,1,1,2},{2,1,1,1,2},{1,1,1,1,2},{1,1,2,2,2}},
  {{2,0,0,0,2},{0,1,2,0,2},{2,1,0,1,1},{1,1,2,0,2},{1,1,2,0,2}},
  {{1,1,2,0,2},{1,1,0,0,0},{0,0,0,0,2},{2,0,2,1,1},{2,0,2,1,1}},
  {{2,0,0,0,2},{0,1,1,1,0},{0,1,1,1,0},{0,1,1,1,0},{2,0,0,0,2}},
  {{1,1,1,1,1},{1,2,2,2,2},{2,2,2,2,2},{1,1,2,2,2},{1,1,2,2,2}},
  {{1,1,0,1,1},{1,1,2,1,1},{0,2,0,2,0},{1,1,0,1,1},{1,2,0,2,1}},
  {{1,2,0,0,1},{1,0,2,0,2},{2,0,2,0,2},{0,0,2,0,2},{2,2,0,1,1}},
  {{1,2,2,1,1},{1,2,2,1,1},{2,2,2,1,1},{1,2,2,1,1},{1,2,2,1,1}}
};
    
void numap_create()
{
    int i;
    int x, y;
    int x1, y1;
    int xx, yy;
    
    int r;

    unsigned int dummy;

    unsigned int StageTempleteNo = 0;

    unsigned int StageTemplete[3][3] = {{0,6,3}, {1,1,1}, {4,5,5}};

    unsigned int StageParts0[5][5] =
        {{1,1,1,1,1},{1,1,1,1,1},{1,1,0,0,0},{1,1,0,1,1},{1,1,0,1,1}};

    for (i = 0; i <= 16; i++) {
        StageMap[0][i] = 1;
        StageMap[16][i] = 1;
        StageMap[i][0] = 1;
        StageMap[i][16] = 1;
    }

    for (x = 0; x <= 4; x++) {
        for (y = 0; y <= 4; y++) {
            StageParts[0][0][y][x] = StageParts0[y][x];
        }
    }
    
    for (i = 0; i <= 9; i++ ) {
        for (x = 0; x <= 4; x++) {
            for (y = 0; y <= 4; y++) {
                StageParts[1][i][y][x] = StageParts12[i][y][x];
                StageParts[2][i][y][x] = StageParts12[i][x][y];
            }
        }
    }
    
    for (i = 0; i <= 14; i++ ) {
        for (x = 0; x <= 4; x++) {
            for (y = 0; y <= 4; y++) {
                StageParts[3][i][y][x] = StageParts3456[i][y][x];
                StageParts[4][i][y][x] = StageParts3456[i][x][y];
                StageParts[5][i][y][x] = StageParts3456[i][4 - y][x];
                StageParts[6][i][y][x] = StageParts3456[i][y][4 - x];
            }
        }
    }

    for (y = 0; y <= 2; y++) {
        for (x = 0; x <= 2; x++) {
            StageTempleteNo = StageTemplete[y][x];
            if (StageTempleteNo == 0) {
                for (y1 = 0; y1 <= 4; y1++) {
                    for (x1 = 0; x1 <= 4; x1++) {
                        StageMap[y*5+y1+1][x*5+x1+1] =
                            StageParts[0][0][y1][x1];
                    }
                }
            }
            if (StageTempleteNo == 1 || StageTempleteNo == 2) {
                r = random(10);
                if (r < 0) {
                    r = random(10);
                }
                for (y1 = 0; y1 <= 4; y1++) {
                    for (x1 = 0; x1 <= 4; x1++) {
                        StageMap[y*5+y1+1][x*5+x1+1] =
                            StageParts[StageTempleteNo][r][y1][x1];
                    }
                }
            }
            if (StageTempleteNo >= 3 && StageTempleteNo <= 6) {
                r = random(15);
                if (r < 0) {
                    r = random(10);
                }
                for (y1 = 0; y1 <= 4; y1++) {
                    for (x1 = 0; x1 <= 4; x1++) {
                        StageMap[y*5+y1+1][x*5+x1+1] =
                            StageParts[StageTempleteNo][r][y1][x1];
                    }
                }
            }
        }
    }
        
    Gold = 0;
    for (y = 0; y < 17; y++) {
        for (x = 0; x < 17; x++) {
            if (StageMap[y][x] == 2) {
                Gold++;
            }
        }
    }

    MaxGold = Gold;
    numap_setnu(3, 3);
}

void numap_setnu(unsigned int x, unsigned int y)
{
    Nux = x;
    Nuy = y;
}

int numap_sumgold(void)
{
    return MaxGold;
}

int numap_restgold(void)
{
    return Gold;
}

int numap_nux(void)
{
    return Nux;
}

int numap_nuy(void)
{
    return Nuy;
}

void numap_movenu(int dx, int dy)
{
    unsigned int NewX, NewY;
    NewX = (unsigned int)((int)Nux + dx);
    NewY = (unsigned int)((int)Nuy + dy);
    if(StageMap[Nuy + dy][NewX] != 1) {
        if(StageMap[NewY][NewX] == 2) {
            StageMap[NewY][NewX] = 1;
            Gold--;
        }
        Nux = NewX;
        Nuy = NewY;
    }
}

int numap_getmap(unsigned int x, unsigned int y)
{
    return StageMap[y][x];
}
